org.apache.cassandra.io.sstable

## Class SSTableRewriter

- java.lang.Object
- - org.apache.cassandra.io.sstable.SSTableRewriter

-     public class SSTableRewriter
      extends java.lang.Object

  Wraps one or more writers as output for rewriting one or more readers: every sstable_preemptive_open_interval_in_mb we look in the summary we're collecting for the latest writer for the penultimate key that we know to have been fully flushed to the index file, and then double check that the key is fully present in the flushed data file. Then we move the starts of each reader forwards to that point, replace them in the datatracker, and attach a runnable for on-close (i.e. when all references expire) that drops the page cache prior to that key position hard-links are created for each partially written sstable so that readers opened against them continue to work past the rename of the temporary file, which is deleted once all readers against the hard-link have been closed. If for any reason the writer is rolled over, we immediately rename and fully expose the completed file in the DataTracker. On abort we restore the original lower bounds to the existing readers and delete any temporary files we had in progress, but leave any hard-links in place for the readers we opened to cleanup when they're finished as we would had we finished successfully.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SSTableRewriter(ColumnFamilyStore cfs, java.util.Set<SSTableReader> rewriting, long maxAge, boolean isOffline)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `abort()`
    `RowIndexEntry` | `append(AbstractCompactedRow row)`
    `SSTableWriter` | `currentWriter()`
    `java.util.List<SSTableReader>` | `finish()`
    `java.util.List<SSTableReader>` | `finish(long repairedAt)` Finishes the new file(s) Creates final files, adds the new files to the dataTracker (via replaceReader).
    `void` | `switchWriter(SSTableWriter newWriter)`
    `RowIndexEntry` | `tryAppend(AbstractCompactedRow row)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SSTableRewriter

          public SSTableRewriter(ColumnFamilyStore cfs,
                         java.util.Set<SSTableReader> rewriting,
                         long maxAge,
                         boolean isOffline)

  - ### Method Detail

    - #### currentWriter

          public SSTableWriter currentWriter()

    - #### append

          public RowIndexEntry append(AbstractCompactedRow row)

    - #### tryAppend

          public RowIndexEntry tryAppend(AbstractCompactedRow row)

    - #### abort

          public void abort()

    - #### switchWriter

          public void switchWriter(SSTableWriter newWriter)

    - #### finish

          public java.util.List<SSTableReader> finish()

    - #### finish

          public java.util.List<SSTableReader> finish(long repairedAt)

      Finishes the new file(s) Creates final files, adds the new files to the dataTracker (via replaceReader). We add them to the tracker to be able to get rid of the tmpfiles It is up to the caller to do the compacted sstables replacement gymnastics (ie, call DataTracker#markCompactedSSTablesReplaced(..))
      Parameters:
        `repairedAt` - the repair time, -1 if we should use the time we supplied when we created the SSTableWriter (and called rewriter.switchWriter(..)), actual time if we want to override the repair time.

Copyright © 2014 The Apache Software Foundation